package birnesoft.wheel;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "birnesoft.wheel", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "birnesoft.wheel", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Timer[] _timer = null;
public static int[] _pp = null;
public static int[] _maxp = null;
public static String[] _vv = null;
public static String[][] _val = null;
public anywheresoftware.b4a.objects.collections.Map _wmap = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper[] _sv = null;
public static int _svstep = 0;
public anywheresoftware.b4a.objects.PanelWrapper _wheelpnl = null;
public anywheresoftware.b4a.objects.PanelWrapper _overlay = null;
public static int _svwidth = 0;
public static int _svheight = 0;
public static int _lblheight = 0;
public anywheresoftware.b4a.objects.LabelWrapper _datelbl = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 18;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(131072);
 BA.debugLineNum = 20;BA.debugLine="Activity.LoadLayout(\"main\")";
Debug.ShouldStop(524288);
mostCurrent._activity.LoadLayout("main",mostCurrent.activityBA);
 BA.debugLineNum = 22;BA.debugLine="set_wheel";
Debug.ShouldStop(2097152);
_set_wheel();
 BA.debugLineNum = 23;BA.debugLine="End Sub";
Debug.ShouldStop(4194304);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 30;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 32;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 26;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 28;BA.debugLine="End Sub";
Debug.ShouldStop(134217728);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 46653, new int[] {6} );}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 BA.debugLineNum = 6;BA.debugLine="Sub Globals";
 BA.debugLineNum = 8;BA.debugLine="Dim pp(5), Maxp(5) As Int   'ScrollView Positions";
_pp = new int[(int)(5)];
;
_maxp = new int[(int)(5)];
;
 BA.debugLineNum = 9;BA.debugLine="Dim vv(5), val(5,34) As String   'selected value";
mostCurrent._vv = new String[(int)(5)];
java.util.Arrays.fill(mostCurrent._vv,"");
mostCurrent._val = new String[(int)(5)][];
{
int d0 = mostCurrent._val.length;
int d1 = (int)(34);
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._val[i0] = new String[d1];
java.util.Arrays.fill(mostCurrent._val[i0],"");
}
}
;
 BA.debugLineNum = 10;BA.debugLine="Dim wmap As Map";
mostCurrent._wmap = new anywheresoftware.b4a.objects.collections.Map();
 BA.debugLineNum = 11;BA.debugLine="Dim sv(5) As ScrollView";
mostCurrent._sv = new anywheresoftware.b4a.objects.ScrollViewWrapper[(int)(5)];
{
int d0 = mostCurrent._sv.length;
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._sv[i0] = new anywheresoftware.b4a.objects.ScrollViewWrapper();
}
}
;
 BA.debugLineNum = 12;BA.debugLine="Dim svstep As Int";
_svstep = 0;
 BA.debugLineNum = 13;BA.debugLine="Dim wheelpnl, Overlay As Panel";
mostCurrent._wheelpnl = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._overlay = new anywheresoftware.b4a.objects.PanelWrapper();
 BA.debugLineNum = 14;BA.debugLine="Dim svwidth, svheight, lblheight As Int";
_svwidth = 0;
_svheight = 0;
_lblheight = 0;
 BA.debugLineNum = 15;BA.debugLine="Dim datelbl As Label";
mostCurrent._datelbl = new anywheresoftware.b4a.objects.LabelWrapper();
 BA.debugLineNum = 16;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 BA.debugLineNum = 1;BA.debugLine="Sub Process_Globals";
 BA.debugLineNum = 2;BA.debugLine="Dim Timer(5) As Timer";
_timer = new anywheresoftware.b4a.objects.Timer[(int)(5)];
{
int d0 = _timer.length;
for (int i0 = 0;i0 < d0;i0++) {
_timer[i0] = new anywheresoftware.b4a.objects.Timer();
}
}
;
 BA.debugLineNum = 4;BA.debugLine="End Sub";
return "";
}
public static String  _scrollviewx_scrollchanged(int _position) throws Exception{
		Debug.PushSubsStack("ScrollViewX_ScrollChanged (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _index = 0;
anywheresoftware.b4a.objects.ScrollViewWrapper _sv1 = null;
Debug.locals.put("Position", _position);
 BA.debugLineNum = 163;BA.debugLine="Sub ScrollViewX_ScrollChanged(Position As Int)";
Debug.ShouldStop(4);
 BA.debugLineNum = 164;BA.debugLine="Dim index As Int";
Debug.ShouldStop(8);
_index = 0;Debug.locals.put("index", _index);
 BA.debugLineNum = 165;BA.debugLine="Dim sv1 As ScrollView";
Debug.ShouldStop(16);
_sv1 = new anywheresoftware.b4a.objects.ScrollViewWrapper();Debug.locals.put("sv1", _sv1);
 BA.debugLineNum = 166;BA.debugLine="sv1 = Sender";
Debug.ShouldStop(32);
_sv1.setObject((android.widget.ScrollView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 BA.debugLineNum = 167;BA.debugLine="index = sv1.Tag";
Debug.ShouldStop(64);
_index = (int)(BA.ObjectToNumber(_sv1.getTag()));Debug.locals.put("index", _index);
 BA.debugLineNum = 168;BA.debugLine="pp(index) = Position";
Debug.ShouldStop(128);
_pp[_index] = _position;
 BA.debugLineNum = 169;BA.debugLine="If pp(index) > (Maxp(index)-1)* svstep Then";
Debug.ShouldStop(256);
if (_pp[_index]>(_maxp[_index]-1)*_svstep) { 
 BA.debugLineNum = 170;BA.debugLine="pp(index) = svstep";
Debug.ShouldStop(512);
_pp[_index] = _svstep;
 BA.debugLineNum = 171;BA.debugLine="sv(index).ScrollPosition =pp(index) 'Round(pp(index)/svstep)* svstep+5";
Debug.ShouldStop(1024);
mostCurrent._sv[_index].setScrollPosition(_pp[_index]);
 };
 BA.debugLineNum = 173;BA.debugLine="If pp(index) < svstep  Then";
Debug.ShouldStop(4096);
if (_pp[_index]<_svstep) { 
 BA.debugLineNum = 174;BA.debugLine="pp(index) = ( Maxp(index)-1)* svstep";
Debug.ShouldStop(8192);
_pp[_index] = (int)((_maxp[_index]-1)*_svstep);
 BA.debugLineNum = 175;BA.debugLine="sv(index).ScrollPosition = pp(index) 'Round(pp(index)/svstep)* svstep+5";
Debug.ShouldStop(16384);
mostCurrent._sv[_index].setScrollPosition(_pp[_index]);
 };
 BA.debugLineNum = 177;BA.debugLine="Timer(index).Enabled = True";
Debug.ShouldStop(65536);
_timer[_index].setEnabled(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 178;BA.debugLine="End Sub";
Debug.ShouldStop(131072);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _set_val() throws Exception{
		Debug.PushSubsStack("set_val (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _k = 0;
 BA.debugLineNum = 93;BA.debugLine="Sub set_val";
Debug.ShouldStop(268435456);
 BA.debugLineNum = 95;BA.debugLine="wmap.Initialize";
Debug.ShouldStop(1073741824);
mostCurrent._wmap.Initialize();
 BA.debugLineNum = 97;BA.debugLine="For k = 1 To 31";
Debug.ShouldStop(1);
{
final double step72 = 1;
final double limit72 = (int)(31);
for (_k = (int)(1); (step72 > 0 && _k <= limit72) || (step72 < 0 && _k >= limit72); _k += step72) {
Debug.locals.put("k", _k);
 BA.debugLineNum = 98;BA.debugLine="val(0,k) = k";
Debug.ShouldStop(2);
mostCurrent._val[(int)(0)][_k] = BA.NumberToString(_k);
 }
}Debug.locals.put("k", _k);
;
 BA.debugLineNum = 100;BA.debugLine="For k = 1 To 21";
Debug.ShouldStop(8);
{
final double step75 = 1;
final double limit75 = (int)(21);
for (_k = (int)(1); (step75 > 0 && _k <= limit75) || (step75 < 0 && _k >= limit75); _k += step75) {
Debug.locals.put("k", _k);
 BA.debugLineNum = 101;BA.debugLine="val(2,k) = k + 9";
Debug.ShouldStop(16);
mostCurrent._val[(int)(2)][_k] = BA.NumberToString(_k+9);
 }
}Debug.locals.put("k", _k);
;
 BA.debugLineNum = 104;BA.debugLine="For k = 1 To 10";
Debug.ShouldStop(128);
{
final double step78 = 1;
final double limit78 = (int)(10);
for (_k = (int)(1); (step78 > 0 && _k <= limit78) || (step78 < 0 && _k >= limit78); _k += step78) {
Debug.locals.put("k", _k);
 BA.debugLineNum = 105;BA.debugLine="val(3,k) = k-1";
Debug.ShouldStop(256);
mostCurrent._val[(int)(3)][_k] = BA.NumberToString(_k-1);
 BA.debugLineNum = 106;BA.debugLine="val(4,k) = k-1";
Debug.ShouldStop(512);
mostCurrent._val[(int)(4)][_k] = BA.NumberToString(_k-1);
 }
}Debug.locals.put("k", _k);
;
 BA.debugLineNum = 108;BA.debugLine="val(0,0) = 31";
Debug.ShouldStop(2048);
mostCurrent._val[(int)(0)][(int)(0)] = BA.NumberToString(31);
 BA.debugLineNum = 109;BA.debugLine="val(2,0) = 30";
Debug.ShouldStop(4096);
mostCurrent._val[(int)(2)][(int)(0)] = BA.NumberToString(30);
 BA.debugLineNum = 110;BA.debugLine="val(3,0) = 9";
Debug.ShouldStop(8192);
mostCurrent._val[(int)(3)][(int)(0)] = BA.NumberToString(9);
 BA.debugLineNum = 111;BA.debugLine="val(4,0) = 9";
Debug.ShouldStop(16384);
mostCurrent._val[(int)(4)][(int)(0)] = BA.NumberToString(9);
 BA.debugLineNum = 112;BA.debugLine="val(0,32) = 1";
Debug.ShouldStop(32768);
mostCurrent._val[(int)(0)][(int)(32)] = BA.NumberToString(1);
 BA.debugLineNum = 113;BA.debugLine="val(2,22) = 10";
Debug.ShouldStop(65536);
mostCurrent._val[(int)(2)][(int)(22)] = BA.NumberToString(10);
 BA.debugLineNum = 114;BA.debugLine="val(3,11) = 0";
Debug.ShouldStop(131072);
mostCurrent._val[(int)(3)][(int)(11)] = BA.NumberToString(0);
 BA.debugLineNum = 115;BA.debugLine="val(4,11) = 0";
Debug.ShouldStop(262144);
mostCurrent._val[(int)(4)][(int)(11)] = BA.NumberToString(0);
 BA.debugLineNum = 117;BA.debugLine="wmap.Put(\"Jan\",\"01\")";
Debug.ShouldStop(1048576);
mostCurrent._wmap.Put((Object)("Jan"),(Object)("01"));
 BA.debugLineNum = 118;BA.debugLine="wmap.Put(\"Feb\",\"02\")";
Debug.ShouldStop(2097152);
mostCurrent._wmap.Put((Object)("Feb"),(Object)("02"));
 BA.debugLineNum = 119;BA.debugLine="wmap.Put(\"Mar\",\"03\")";
Debug.ShouldStop(4194304);
mostCurrent._wmap.Put((Object)("Mar"),(Object)("03"));
 BA.debugLineNum = 120;BA.debugLine="wmap.Put(\"Apr\",\"04\")";
Debug.ShouldStop(8388608);
mostCurrent._wmap.Put((Object)("Apr"),(Object)("04"));
 BA.debugLineNum = 121;BA.debugLine="wmap.Put(\"May\",\"05\")";
Debug.ShouldStop(16777216);
mostCurrent._wmap.Put((Object)("May"),(Object)("05"));
 BA.debugLineNum = 122;BA.debugLine="wmap.Put(\"Jun\",\"06\")";
Debug.ShouldStop(33554432);
mostCurrent._wmap.Put((Object)("Jun"),(Object)("06"));
 BA.debugLineNum = 123;BA.debugLine="wmap.Put(\"Jul\",\"07\")";
Debug.ShouldStop(67108864);
mostCurrent._wmap.Put((Object)("Jul"),(Object)("07"));
 BA.debugLineNum = 124;BA.debugLine="wmap.Put(\"Aug\",\"08\")";
Debug.ShouldStop(134217728);
mostCurrent._wmap.Put((Object)("Aug"),(Object)("08"));
 BA.debugLineNum = 125;BA.debugLine="wmap.Put(\"Sep\",\"09\")";
Debug.ShouldStop(268435456);
mostCurrent._wmap.Put((Object)("Sep"),(Object)("09"));
 BA.debugLineNum = 126;BA.debugLine="wmap.Put(\"Oct\",\"10\")";
Debug.ShouldStop(536870912);
mostCurrent._wmap.Put((Object)("Oct"),(Object)("10"));
 BA.debugLineNum = 127;BA.debugLine="wmap.Put(\"Nov\",\"11\")";
Debug.ShouldStop(1073741824);
mostCurrent._wmap.Put((Object)("Nov"),(Object)("11"));
 BA.debugLineNum = 128;BA.debugLine="wmap.Put(\"Dec\",\"12\")";
Debug.ShouldStop(-2147483648);
mostCurrent._wmap.Put((Object)("Dec"),(Object)("12"));
 BA.debugLineNum = 129;BA.debugLine="val(1,0) = \"Dec\"";
Debug.ShouldStop(1);
mostCurrent._val[(int)(1)][(int)(0)] = "Dec";
 BA.debugLineNum = 130;BA.debugLine="val(1,1) = \"Jan\"";
Debug.ShouldStop(2);
mostCurrent._val[(int)(1)][(int)(1)] = "Jan";
 BA.debugLineNum = 131;BA.debugLine="val(1,2) = \"Feb\"";
Debug.ShouldStop(4);
mostCurrent._val[(int)(1)][(int)(2)] = "Feb";
 BA.debugLineNum = 132;BA.debugLine="val(1,3) = \"Mar\"";
Debug.ShouldStop(8);
mostCurrent._val[(int)(1)][(int)(3)] = "Mar";
 BA.debugLineNum = 133;BA.debugLine="val(1,4) = \"Apr\"";
Debug.ShouldStop(16);
mostCurrent._val[(int)(1)][(int)(4)] = "Apr";
 BA.debugLineNum = 134;BA.debugLine="val(1,5) = \"May\"";
Debug.ShouldStop(32);
mostCurrent._val[(int)(1)][(int)(5)] = "May";
 BA.debugLineNum = 135;BA.debugLine="val(1,6) = \"Jun\"";
Debug.ShouldStop(64);
mostCurrent._val[(int)(1)][(int)(6)] = "Jun";
 BA.debugLineNum = 136;BA.debugLine="val(1,7) = \"Jul\"";
Debug.ShouldStop(128);
mostCurrent._val[(int)(1)][(int)(7)] = "Jul";
 BA.debugLineNum = 137;BA.debugLine="val(1,8) = \"Aug\"";
Debug.ShouldStop(256);
mostCurrent._val[(int)(1)][(int)(8)] = "Aug";
 BA.debugLineNum = 138;BA.debugLine="val(1,9) = \"Sep\"";
Debug.ShouldStop(512);
mostCurrent._val[(int)(1)][(int)(9)] = "Sep";
 BA.debugLineNum = 139;BA.debugLine="val(1,10) = \"Oct\"";
Debug.ShouldStop(1024);
mostCurrent._val[(int)(1)][(int)(10)] = "Oct";
 BA.debugLineNum = 140;BA.debugLine="val(1,11) = \"Nov\"";
Debug.ShouldStop(2048);
mostCurrent._val[(int)(1)][(int)(11)] = "Nov";
 BA.debugLineNum = 141;BA.debugLine="val(1,12) = \"Dec\"";
Debug.ShouldStop(4096);
mostCurrent._val[(int)(1)][(int)(12)] = "Dec";
 BA.debugLineNum = 142;BA.debugLine="val(1,13) = \"Jan\"";
Debug.ShouldStop(8192);
mostCurrent._val[(int)(1)][(int)(13)] = "Jan";
 BA.debugLineNum = 144;BA.debugLine="End Sub";
Debug.ShouldStop(32768);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _set_wheel() throws Exception{
		Debug.PushSubsStack("set_wheel (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _ii = 0;
int _i = 0;
String _sty1 = "";
String _sty2 = "";
int _xp = 0;
 BA.debugLineNum = 38;BA.debugLine="Sub set_wheel";
Debug.ShouldStop(32);
 BA.debugLineNum = 39;BA.debugLine="svwidth = 50";
Debug.ShouldStop(64);
_svwidth = (int)(50);
 BA.debugLineNum = 40;BA.debugLine="svheight = 100";
Debug.ShouldStop(128);
_svheight = (int)(100);
 BA.debugLineNum = 41;BA.debugLine="Maxp(0) = 33";
Debug.ShouldStop(256);
_maxp[(int)(0)] = (int)(33);
 BA.debugLineNum = 42;BA.debugLine="Maxp(1) = 14";
Debug.ShouldStop(512);
_maxp[(int)(1)] = (int)(14);
 BA.debugLineNum = 43;BA.debugLine="Maxp(2) = 23";
Debug.ShouldStop(1024);
_maxp[(int)(2)] = (int)(23);
 BA.debugLineNum = 44;BA.debugLine="Maxp(3) = 12";
Debug.ShouldStop(2048);
_maxp[(int)(3)] = (int)(12);
 BA.debugLineNum = 45;BA.debugLine="Maxp(4) = 12";
Debug.ShouldStop(4096);
_maxp[(int)(4)] = (int)(12);
 BA.debugLineNum = 46;BA.debugLine="svstep = 35";
Debug.ShouldStop(8192);
_svstep = (int)(35);
 BA.debugLineNum = 47;BA.debugLine="set_val";
Debug.ShouldStop(16384);
_set_val();
 BA.debugLineNum = 49;BA.debugLine="wheelpnl.Initialize(\"\")";
Debug.ShouldStop(65536);
mostCurrent._wheelpnl.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 50;BA.debugLine="wheelpnl.Color = Colors.Gray";
Debug.ShouldStop(131072);
mostCurrent._wheelpnl.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 BA.debugLineNum = 51;BA.debugLine="Activity.AddView(wheelpnl,100dip, 100dip,208dip,( svheight+20)*1dip)";
Debug.ShouldStop(262144);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._wheelpnl.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(208)),(int)((_svheight+20)*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))));
 BA.debugLineNum = 52;BA.debugLine="Overlay.Initialize(\"\")";
Debug.ShouldStop(524288);
mostCurrent._overlay.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 53;BA.debugLine="wheelpnl.AddView(Overlay,10*1dip, 10*1dip, wheelpnl.Width-20*1dip,wheelpnl.height-20*1dip)";
Debug.ShouldStop(1048576);
mostCurrent._wheelpnl.AddView((android.view.View)(mostCurrent._overlay.getObject()),(int)(10*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))),(int)(10*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))),(int)(mostCurrent._wheelpnl.getWidth()-20*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))),(int)(mostCurrent._wheelpnl.getHeight()-20*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))));
 BA.debugLineNum = 54;BA.debugLine="Overlay.SetBackgroundImage(LoadBitmap(File.DirAssets,\"bg1.png\"))";
Debug.ShouldStop(2097152);
mostCurrent._overlay.SetBackgroundImage((android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"bg1.png").getObject()));
 BA.debugLineNum = 56;BA.debugLine="For ii = 0 To 4";
Debug.ShouldStop(8388608);
{
final double step37 = 1;
final double limit37 = (int)(4);
for (_ii = (int)(0); (step37 > 0 && _ii <= limit37) || (step37 < 0 && _ii >= limit37); _ii += step37) {
Debug.locals.put("ii", _ii);
 BA.debugLineNum = 57;BA.debugLine="Timer(ii).Initialize(\"TimerX\", 700+ii) ' 1000 = 1 second";
Debug.ShouldStop(16777216);
_timer[_ii].Initialize(processBA,"TimerX",(long)(700+_ii));
 BA.debugLineNum = 58;BA.debugLine="sv(ii).Initialize2(666,\"ScrollViewX\")";
Debug.ShouldStop(33554432);
mostCurrent._sv[_ii].Initialize2(mostCurrent.activityBA,(int)(666),"ScrollViewX");
 BA.debugLineNum = 59;BA.debugLine="sv(ii).Tag = ii";
Debug.ShouldStop(67108864);
mostCurrent._sv[_ii].setTag((Object)(_ii));
 }
}Debug.locals.put("ii", _ii);
;
 BA.debugLineNum = 62;BA.debugLine="wheelpnl.AddView(sv(0),11dip ,10dip,45dip,svheight*1dip)";
Debug.ShouldStop(536870912);
mostCurrent._wheelpnl.AddView((android.view.View)(mostCurrent._sv[(int)(0)].getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(11)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(45)),(int)(_svheight*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))));
 BA.debugLineNum = 63;BA.debugLine="wheelpnl.AddView(sv(1),56dip,10dip,57dip,svheight*1dip)";
Debug.ShouldStop(1073741824);
mostCurrent._wheelpnl.AddView((android.view.View)(mostCurrent._sv[(int)(1)].getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(56)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(57)),(int)(_svheight*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))));
 BA.debugLineNum = 64;BA.debugLine="wheelpnl.AddView(sv(2),113dip,10dip,45*1dip,svheight*1dip)";
Debug.ShouldStop(-2147483648);
mostCurrent._wheelpnl.AddView((android.view.View)(mostCurrent._sv[(int)(2)].getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(113)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10)),(int)(45*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))),(int)(_svheight*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))));
 BA.debugLineNum = 65;BA.debugLine="wheelpnl.AddView(sv(3),148dip,10dip,25dip,svheight*1dip)";
Debug.ShouldStop(1);
mostCurrent._wheelpnl.AddView((android.view.View)(mostCurrent._sv[(int)(3)].getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(148)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(25)),(int)(_svheight*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))));
 BA.debugLineNum = 66;BA.debugLine="wheelpnl.AddView(sv(4),173dip,10dip,25dip,svheight*1dip)";
Debug.ShouldStop(2);
mostCurrent._wheelpnl.AddView((android.view.View)(mostCurrent._sv[(int)(4)].getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(173)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(25)),(int)(_svheight*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))));
 BA.debugLineNum = 67;BA.debugLine="For i = 0 To 4";
Debug.ShouldStop(4);
{
final double step47 = 1;
final double limit47 = (int)(4);
for (_i = (int)(0); (step47 > 0 && _i <= limit47) || (step47 < 0 && _i >= limit47); _i += step47) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 68;BA.debugLine="SetupScrollViews(i,Maxp(i))";
Debug.ShouldStop(8);
_setupscrollviews(_i,_maxp[_i]);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 71;BA.debugLine="DoEvents";
Debug.ShouldStop(64);
anywheresoftware.b4a.keywords.Common.DoEvents();
 BA.debugLineNum = 73;BA.debugLine="pp(0) = DateTime.GetDayOfMonth(DateTime.Now) * svstep";
Debug.ShouldStop(256);
_pp[(int)(0)] = (int)(anywheresoftware.b4a.keywords.Common.DateTime.GetDayOfMonth(anywheresoftware.b4a.keywords.Common.DateTime.getNow())*_svstep);
 BA.debugLineNum = 74;BA.debugLine="pp(1) = DateTime.GetMonth(DateTime.Now) * svstep";
Debug.ShouldStop(512);
_pp[(int)(1)] = (int)(anywheresoftware.b4a.keywords.Common.DateTime.GetMonth(anywheresoftware.b4a.keywords.Common.DateTime.getNow())*_svstep);
 BA.debugLineNum = 75;BA.debugLine="pp(2) = (Floor(DateTime.GetYear(DateTime.Now)/100)-9 )* svstep";
Debug.ShouldStop(1024);
_pp[(int)(2)] = (int)((anywheresoftware.b4a.keywords.Common.Floor(anywheresoftware.b4a.keywords.Common.DateTime.GetYear(anywheresoftware.b4a.keywords.Common.DateTime.getNow())/(double)100)-9)*_svstep);
 BA.debugLineNum = 76;BA.debugLine="Dim sty1, sty2 As String";
Debug.ShouldStop(2048);
_sty1 = "";Debug.locals.put("sty1", _sty1);
_sty2 = "";Debug.locals.put("sty2", _sty2);
 BA.debugLineNum = 77;BA.debugLine="sty1 = DateTime.GetYear(DateTime.Now)";
Debug.ShouldStop(4096);
_sty1 = BA.NumberToString(anywheresoftware.b4a.keywords.Common.DateTime.GetYear(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));Debug.locals.put("sty1", _sty1);
 BA.debugLineNum = 78;BA.debugLine="Dim xp As Int";
Debug.ShouldStop(8192);
_xp = 0;Debug.locals.put("xp", _xp);
 BA.debugLineNum = 79;BA.debugLine="sty2 = sty1.CharAt(2)";
Debug.ShouldStop(16384);
_sty2 = String.valueOf(_sty1.charAt((int)(2)));Debug.locals.put("sty2", _sty2);
 BA.debugLineNum = 80;BA.debugLine="xp = (sty2+1) * svstep";
Debug.ShouldStop(32768);
_xp = (int)(((double)(Double.parseDouble(_sty2))+1)*_svstep);Debug.locals.put("xp", _xp);
 BA.debugLineNum = 81;BA.debugLine="pp(3) = xp";
Debug.ShouldStop(65536);
_pp[(int)(3)] = _xp;
 BA.debugLineNum = 82;BA.debugLine="sty2 = sty1.CharAt(3)";
Debug.ShouldStop(131072);
_sty2 = String.valueOf(_sty1.charAt((int)(3)));Debug.locals.put("sty2", _sty2);
 BA.debugLineNum = 83;BA.debugLine="xp = (sty2+1) * svstep";
Debug.ShouldStop(262144);
_xp = (int)(((double)(Double.parseDouble(_sty2))+1)*_svstep);Debug.locals.put("xp", _xp);
 BA.debugLineNum = 84;BA.debugLine="pp(4) = xp";
Debug.ShouldStop(524288);
_pp[(int)(4)] = _xp;
 BA.debugLineNum = 85;BA.debugLine="For ii = 0 To 4";
Debug.ShouldStop(1048576);
{
final double step63 = 1;
final double limit63 = (int)(4);
for (_ii = (int)(0); (step63 > 0 && _ii <= limit63) || (step63 < 0 && _ii >= limit63); _ii += step63) {
Debug.locals.put("ii", _ii);
 BA.debugLineNum = 86;BA.debugLine="vv(ii) = val(ii,Round(pp(ii)/svstep))";
Debug.ShouldStop(2097152);
mostCurrent._vv[_ii] = mostCurrent._val[_ii][(int)(anywheresoftware.b4a.keywords.Common.Round(_pp[_ii]/(double)_svstep))];
 BA.debugLineNum = 87;BA.debugLine="sv(ii).ScrollPosition = Round(pp(ii)/svstep) * svstep + 5dip";
Debug.ShouldStop(4194304);
mostCurrent._sv[_ii].setScrollPosition((int)(anywheresoftware.b4a.keywords.Common.Round(_pp[_ii]/(double)_svstep)*_svstep+anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(5))));
 }
}Debug.locals.put("ii", _ii);
;
 BA.debugLineNum = 89;BA.debugLine="wheelpnl.BringToFront";
Debug.ShouldStop(16777216);
mostCurrent._wheelpnl.BringToFront();
 BA.debugLineNum = 90;BA.debugLine="Overlay.BringToFront 'Transparent PNG.";
Debug.ShouldStop(33554432);
mostCurrent._overlay.BringToFront();
 BA.debugLineNum = 91;BA.debugLine="End Sub";
Debug.ShouldStop(67108864);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _setupscrollviews(int _ii,int _z) throws Exception{
		Debug.PushSubsStack("SetupScrollViews (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _lw = 0;
int _i = 0;
anywheresoftware.b4a.objects.LabelWrapper _lbl = null;
Debug.locals.put("ii", _ii);
Debug.locals.put("z", _z);
 BA.debugLineNum = 146;BA.debugLine="Sub SetupScrollViews(ii As Int, z As Int)";
Debug.ShouldStop(131072);
 BA.debugLineNum = 147;BA.debugLine="Dim lw As Int";
Debug.ShouldStop(262144);
_lw = 0;Debug.locals.put("lw", _lw);
 BA.debugLineNum = 148;BA.debugLine="For i = 0 To z";
Debug.ShouldStop(524288);
{
final double step119 = 1;
final double limit119 = _z;
for (_i = (int)(0); (step119 > 0 && _i <= limit119) || (step119 < 0 && _i >= limit119); _i += step119) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 149;BA.debugLine="Dim lbl As Label";
Debug.ShouldStop(1048576);
_lbl = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("lbl", _lbl);
 BA.debugLineNum = 150;BA.debugLine="lbl.Initialize(\"\")";
Debug.ShouldStop(2097152);
_lbl.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 151;BA.debugLine="lbl.Color = Colors.LightGray";
Debug.ShouldStop(4194304);
_lbl.setColor(anywheresoftware.b4a.keywords.Common.Colors.LightGray);
 BA.debugLineNum = 152;BA.debugLine="lbl.textColor = Colors.Black";
Debug.ShouldStop(8388608);
_lbl.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 153;BA.debugLine="lbl.TextSize = 24";
Debug.ShouldStop(16777216);
_lbl.setTextSize((float)(24));
 BA.debugLineNum = 154;BA.debugLine="lbl.Gravity = Gravity.CENTER";
Debug.ShouldStop(33554432);
_lbl.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER);
 BA.debugLineNum = 155;BA.debugLine="lbl.Text = val(ii,i)";
Debug.ShouldStop(67108864);
_lbl.setText((Object)(mostCurrent._val[_ii][_i]));
 BA.debugLineNum = 156;BA.debugLine="If ii <2 Then lw = svwidth Else lw = 35";
Debug.ShouldStop(134217728);
if (_ii<2) { 
_lw = _svwidth;Debug.locals.put("lw", _lw);}
else {
_lw = (int)(35);Debug.locals.put("lw", _lw);};
 BA.debugLineNum = 157;BA.debugLine="sv(ii).Panel.AddView(lbl, 0, (i+1)*svstep*1dip, sv(ii).width, svstep)";
Debug.ShouldStop(268435456);
mostCurrent._sv[_ii].getPanel().AddView((android.view.View)(_lbl.getObject()),(int)(0),(int)((_i+1)*_svstep*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))),mostCurrent._sv[_ii].getWidth(),_svstep);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 159;BA.debugLine="sv(ii).Panel.Height = svstep *(z + 3)*1dip";
Debug.ShouldStop(1073741824);
mostCurrent._sv[_ii].getPanel().setHeight((int)(_svstep*(_z+3)*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))));
 BA.debugLineNum = 160;BA.debugLine="sv(ii).Panel.Color = Colors.DarkGray";
Debug.ShouldStop(-2147483648);
mostCurrent._sv[_ii].getPanel().setColor(anywheresoftware.b4a.keywords.Common.Colors.DarkGray);
 BA.debugLineNum = 161;BA.debugLine="End Sub";
Debug.ShouldStop(1);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _timerx_tick() throws Exception{
		Debug.PushSubsStack("TimerX_Tick (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _index = 0;
anywheresoftware.b4a.objects.Timer _ti = null;
 BA.debugLineNum = 180;BA.debugLine="Sub TimerX_Tick";
Debug.ShouldStop(524288);
 BA.debugLineNum = 181;BA.debugLine="Dim index As Int";
Debug.ShouldStop(1048576);
_index = 0;Debug.locals.put("index", _index);
 BA.debugLineNum = 182;BA.debugLine="Dim ti As Timer";
Debug.ShouldStop(2097152);
_ti = new anywheresoftware.b4a.objects.Timer();Debug.locals.put("ti", _ti);
 BA.debugLineNum = 183;BA.debugLine="ti = Sender";
Debug.ShouldStop(4194304);
_ti = (anywheresoftware.b4a.objects.Timer)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA));Debug.locals.put("ti", _ti);
 BA.debugLineNum = 184;BA.debugLine="index = ti.Interval - 700";
Debug.ShouldStop(8388608);
_index = (int)(_ti.getInterval()-700);Debug.locals.put("index", _index);
 BA.debugLineNum = 185;BA.debugLine="sv(index).ScrollPosition = Round(pp(index)/svstep)* svstep+5";
Debug.ShouldStop(16777216);
mostCurrent._sv[_index].setScrollPosition((int)(anywheresoftware.b4a.keywords.Common.Round(_pp[_index]/(double)_svstep)*_svstep+5));
 BA.debugLineNum = 186;BA.debugLine="Timer(index).Enabled = False";
Debug.ShouldStop(33554432);
_timer[_index].setEnabled(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 187;BA.debugLine="vv(index) = val(index,Round(pp(index)/svstep))";
Debug.ShouldStop(67108864);
mostCurrent._vv[_index] = mostCurrent._val[_index][(int)(anywheresoftware.b4a.keywords.Common.Round(_pp[_index]/(double)_svstep))];
 BA.debugLineNum = 189;BA.debugLine="datelbl.Text = vv(0)&\"/\"&wmap.Get(vv(1))&\"/\"&vv(2)&vv(3)&vv(4)";
Debug.ShouldStop(268435456);
mostCurrent._datelbl.setText((Object)(mostCurrent._vv[(int)(0)]+"/"+String.valueOf(mostCurrent._wmap.Get((Object)(mostCurrent._vv[(int)(1)])))+"/"+mostCurrent._vv[(int)(2)]+mostCurrent._vv[(int)(3)]+mostCurrent._vv[(int)(4)]));
 BA.debugLineNum = 190;BA.debugLine="End Sub";
Debug.ShouldStop(536870912);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"Timer",_timer,"pp",_pp,"Maxp",_maxp,"vv",_vv,"val",_val,"wmap",_wmap,"sv",_sv,"svstep",_svstep,"wheelpnl",_wheelpnl,"Overlay",_overlay,"svwidth",_svwidth,"svheight",_svheight,"lblheight",_lblheight,"datelbl",_datelbl};
}
}
